Skip to content
This repository

Tornado is a Python web framework and asynchronous networking library, originally developed at FriendFeed.

Fetching latest commit…

Octocat-spinner-32-eaf2f5

Cannot retrieve the latest commit at this time

Octocat-spinner-32 demos
Octocat-spinner-32 docs
Octocat-spinner-32 maint
Octocat-spinner-32 tornado
Octocat-spinner-32 .coveragerc Add .coveragerc for test coverage reporting. January 21, 2012
Octocat-spinner-32 .gitignore
Octocat-spinner-32 .travis.yml
Octocat-spinner-32 MANIFEST.in
Octocat-spinner-32 README.rst
Octocat-spinner-32 runtests.sh
Octocat-spinner-32 setup.py
Octocat-spinner-32 tox.ini
README.rst

Tornado Web Server

Tornado is a Python web framework and asynchronous networking library, originally developed at FriendFeed. By using non-blocking network I/O, Tornado can scale to tens of thousands of open connections, making it ideal for long polling, WebSockets, and other applications that require a long-lived connection to each user.

Quick links

Hello, world

Here is a simple "Hello, world" example web app for Tornado:

import tornado.ioloop
import tornado.web

class MainHandler(tornado.web.RequestHandler):
    def get(self):
        self.write("Hello, world")

application = tornado.web.Application([
    (r"/", MainHandler),
])

if __name__ == "__main__":
    application.listen(8888)
    tornado.ioloop.IOLoop.instance().start()

This example does not use any of Tornado's asynchronous features; for that see this simple chat room.

Installation

Automatic installation:

pip install tornado

Tornado is listed in PyPI and can be installed with pip or easy_install. Note that the source distribution includes demo applications that are not present when Tornado is installed in this way, so you may wish to download a copy of the source tarball as well.

Manual installation: Download the latest source from PyPI.

tar xvzf tornado-$VERSION.tar.gz
cd tornado-$VERSION
python setup.py build
sudo python setup.py install

The Tornado source code is hosted on GitHub.

Prerequisites: Tornado runs on Python 2.6, 2.7, 3.2, and 3.3. It has no strict dependencies outside the Python standard library, although some features may require one of the following libraries:

  • unittest2 is needed to run Tornado's test suite on Python 2.6 (it is unnecessary on more recent versions of Python)
  • concurrent.futures is the recommended thread pool for use with Tornado and enables the use of tornado.netutil.ThreadedResolver. It is needed only on Python 2; Python 3 includes this package in the standard library.
  • pycurl is used by the optional tornado.curl_httpclient. Libcurl version 7.18.2 or higher is required; version 7.21.1 or higher is recommended.
  • Twisted may be used with the classes in tornado.platform.twisted.
  • pycares is an alternative non-blocking DNS resolver that can be used when threads are not appropriate.
  • Monotime adds support for a monotonic clock, which improves reliability in environments where clock adjustments are frequent. No longer needed in Python 3.3.

Platforms: Tornado should run on any Unix-like platform, although for the best performance and scalability only Linux (with epoll) and BSD (with kqueue) are recommended (even though Mac OS X is derived from BSD and supports kqueue, its networking performance is generally poor so it is recommended only for development use).

Discussion and support

You can discuss Tornado on the Tornado developer mailing list, and report bugs on the GitHub issue trackier. Links to additional resources can be found on the Tornado wiki.

Tornado is one of Facebook's open source technologies. It is available under the Apache License, Version 2.0.

This web site and all documentation is licensed under Creative Commons 3.0.

Something went wrong with that request. Please try again.